/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.stimmzettel;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.stimmzettel.boundary.AbstractStimmzettelKopfdatumSearchParameters;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelKopfdatumChangeEvent;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelKopfdatumConversationStore;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelKopfdatumExtendedDAO;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelKopfdatumSearch;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelKopfdatumSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatum;
import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractStimmzettelKopfdatumSearchView.COMPONENT_NAME)
@View(viewId = AbstractStimmzettelKopfdatumSearchView.VIEW_ID, useCase = UseCasePermission.STIMMZETTEL_KOPFDATUM_SEARCH)
public abstract class AbstractStimmzettelKopfdatumSearchView extends AbstractElectSearchView<StimmzettelKopfdatum> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmzettelKopfdatumSearchView";
  
  public static final String VIEW_ID = "/stimmzettel/stimmzettel-kopfdatum-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractStimmzettelKopfdatumSearchView requestHandler;

  @Inject
  private transient StimmzettelKopfdatumExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(StimmzettelKopfdatumConversationStore.class)
  protected transient StimmzettelKopfdatumConversationStore conversationStore;

  @Inject
  protected transient StimmzettelKopfdatumSearch search;

  @Inject
  @ConversationGroup(AbstractStimmzettelKopfdatumSearchParameters.class)
  protected transient StimmzettelKopfdatumSearchParameters searchParameters;

  @Inject
  protected transient StimmzettelKopfdatumMeta entityMeta;

  public AbstractStimmzettelKopfdatumSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public StimmzettelKopfdatum getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(StimmzettelKopfdatum entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public StimmzettelKopfdatumSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<StimmzettelKopfdatum> getEagerLoadingCollector() {
    return EagerLoadingCollector.<StimmzettelKopfdatum> create();
  }

  @Override
  public List<StimmzettelKopfdatum> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<StimmzettelKopfdatum> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onStimmzettelKopfdatumChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) StimmzettelKopfdatumChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractStimmzettelKopfdatumSearchView {

    @View
    @Inject
    private transient Instance<AbstractStimmzettelKopfdatumSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractStimmzettelKopfdatumSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
